PROGRAM prgMain
  VAR CONSTANT
    IP_Address      : STRING := '192.168.1.125:502';
    chanCode        : UINT   := ETH1_uni0;
    tcp             : BOOL   := true;

    InverterIdx     : USINT  := 1;    (*index v poli zarizeni, pro ktere nastavujeme vykon*)
    INVERTER_COUNT  : USINT  := 4;    (* maximalni pocet zarizeni typu Inverter *)
    DEVICE_COUNT    : USINT  := INVERTER_COUNT;
  END_VAR

  VAR_INPUT
  END_VAR
  VAR_OUTPUT
  END_VAR
  VAR
    smInit : fb_SMInit;
    smInit_enable : BOOL := true;
    smFini : fb_SMFini;
    DeviceInfo : ARRAY [1..DEVICE_COUNT]    OF TDeviceBlockInfo; (*Informace o blocich v jednotlivych zarizenich*)
    Inverter   : ARRAY [1..INVERTER_COUNT]  OF TInverter;
    smPc : fb_SMPowerControl;
    pwctrl_value : UINT := 60; (*pozadovana hodnota vykonu [%]*)
    pc_SR : SR;
    //pc_done : BOOL;
  END_VAR
  VAR_TEMP
  END_VAR
{NOCODE}
<?xml version="1.0" encoding="windows-1250" ?>
<?xml-stylesheet type="text/xsl" href="pokus.xsl" version="1.1"?>
<fbd version="1.1">
<comment id="1" height="3" width="12">
  <position x="3" y="5" />
Schema comment
</comment>
<block name="SR" instance="pc_SR" id="2" height="6" width="6" line="10" order="2">
  <position x="73" y="12" />
  <inVariables>
    <variable name="S1" type="BOOL">
      <connection refid="3" name="done">
        <position x="73" y="15" />
        <position x="72" y="15" />
        <position x="72" y="15" />
        <position x="61" y="15" />
      </connection>
    </variable>
    <variable name="R" type="BOOL">
      <connection refid="47" name="__ENO">
        <position x="73" y="17" />
        <position x="71" y="17" />
        <position x="71" y="9" />
        <position x="127" y="9" />
        <position x="127" y="15" />
        <position x="125" y="15" />
      </connection>
    </variable>
  </inVariables>
  <outVariables>
    <variable name="Q1" type="BOOL">
    </variable>
  </outVariables>
</block>
<block name="fb_SMInit" instance="smInit" id="3" height="30" width="20" line="9" order="1">
  <position x="41" y="12" />
  <inVariables>
    <variable name="enable" type="BOOL">
      <connection refid="4">
        <position x="41" y="15" />
        <position x="18" y="15" />
        <position x="18" y="15" />
        <position x="12" y="15" />
      </connection>
    <comment>if enable=0, block is disabled, start with rising edge</comment>
    </variable>
    <variable name="ip" type="STRING[80]">
      <connection refid="19">
        <position x="41" y="17" />
        <position x="34" y="17" />
        <position x="34" y="17" />
        <position x="33" y="17" />
      </connection>
    <comment>SM2-MU gateway IP address</comment>
    </variable>
    <variable name="chanCode" type="UINT">
      <connection refid="21">
        <position x="41" y="19" />
        <position x="36" y="19" />
        <position x="36" y="19" />
        <position x="35" y="19" />
      </connection>
    <comment>communication channel number</comment>
    </variable>
    <variable name="tcp" type="BOOL">
      <connection refid="20">
        <position x="41" y="21" />
        <position x="38" y="21" />
        <position x="38" y="21" />
        <position x="37" y="21" />
      </connection>
    <comment>protocol type - TRUE = TCP, FALSE = UDP</comment>
    </variable>
    <variable name="DevInfoPtr" type="PTR_TO TDeviceBlockInfo">
      <connection refid="17">
        <position x="41" y="23" />
        <position x="21" y="23" />
        <position x="21" y="27" />
        <position x="14" y="27" />
      </connection>
    <comment>pointer to array start</comment>
    </variable>
    <variable name="DevInfoSize" type="USINT">
      <connection refid="8">
        <position x="41" y="25" />
        <position x="23" y="25" />
        <position x="23" y="30" />
        <position x="14" y="30" />
      </connection>
    <comment>max. number of devices (array size)</comment>
    </variable>
    <variable name="InverterPtr" type="PTR_TO TInverter">
      <connection refid="9">
        <position x="41" y="27" />
        <position x="25" y="27" />
        <position x="25" y="33" />
        <position x="12" y="33" />
      </connection>
    <comment>Pointer to array of Inverter structures</comment>
    </variable>
    <variable name="InverterCount" type="USINT">
      <connection refid="13">
        <position x="41" y="29" />
        <position x="27" y="29" />
        <position x="27" y="36" />
        <position x="15" y="36" />
      </connection>
    <comment>max. number of Inverters (array size)</comment>
    </variable>
    <variable name="StringBoxPtr" type="PTR_TO TStringBox">
      <connection refid="10">
        <position x="41" y="31" />
        <position x="29" y="31" />
        <position x="29" y="39" />
        <position x="3" y="39" />
      </connection>
    <comment>Pointer to array of StringBox structures</comment>
    </variable>
    <variable name="StringBoxCount" type="USINT">
      <connection refid="14">
        <position x="41" y="33" />
        <position x="31" y="33" />
        <position x="31" y="42" />
        <position x="3" y="42" />
      </connection>
    <comment>max. number of Inverters (array size)</comment>
    </variable>
    <variable name="BatteryPtr" type="PTR_TO TBattery">
      <connection refid="11">
        <position x="41" y="35" />
        <position x="33" y="35" />
        <position x="33" y="45" />
        <position x="3" y="45" />
      </connection>
    <comment>Pointer to array of Battery structures</comment>
    </variable>
    <variable name="BatteryCount" type="USINT">
      <connection refid="15">
        <position x="41" y="37" />
        <position x="35" y="37" />
        <position x="35" y="48" />
        <position x="3" y="48" />
      </connection>
    <comment>max. number of Batteries (array size)</comment>
    </variable>
    <variable name="MeterPtr" type="PTR_TO TMeter">
      <connection refid="12">
        <position x="41" y="39" />
        <position x="37" y="39" />
        <position x="37" y="51" />
        <position x="3" y="51" />
      </connection>
    <comment>Pointer to array of Meter structures</comment>
    </variable>
    <variable name="MeterCount" type="USINT">
      <connection refid="16">
        <position x="41" y="41" />
        <position x="39" y="41" />
        <position x="39" y="54" />
        <position x="3" y="54" />
      </connection>
    <comment>max. number of Meters (array size)</comment>
    </variable>
  </inVariables>
  <outVariables>
    <variable name="done" type="BOOL">
    <comment>block finished</comment>
    </variable>
    <variable name="busy" type="BOOL">
    <comment>block is still running</comment>
    </variable>
    <variable name="err" type="BOOL">
    <comment>block ended with error</comment>
    </variable>
    <variable name="errCode" type="USINT">
    <comment>error code</comment>
    </variable>
    <variable name="errTxt" type="STRING[80]">
    <comment>error report</comment>
    </variable>
    <variable name="devCount" type="USINT">
    <comment>number of devices in the SM2-MU gateway</comment>
    </variable>
    <variable name="DevTypeCount" type="TDeviceTypeCount">
    <comment>structure with count of each device type</comment>
    </variable>
  </outVariables>
</block>
<inVariable name="smInit_enable" type="BOOL" id="4">
  <position x="1" y="14" />
</inVariable>
<inVariable name="IP_Address" type="STRING" id="5">
  <position x="1" y="17" />
</inVariable>
<inVariable name="chanCode" type="UINT" id="6">
  <position x="1" y="20" />
</inVariable>
<inVariable name="tcp" type="BOOL" id="7">
  <position x="1" y="23" />
</inVariable>
<inVariable name="DEVICE_COUNT" type="USINT" id="8">
  <position x="1" y="29" />
</inVariable>
<inVariable name="ADR(Inverter)" type="" id="9">
  <position x="0" y="32" />
</inVariable>
<inVariable name="0" type="" id="10">
  <position x="1" y="38" />
</inVariable>
<inVariable name="0" type="" id="11">
  <position x="1" y="44" />
</inVariable>
<inVariable name="0" type="" id="12">
  <position x="1" y="50" />
</inVariable>
<inVariable name="INVERTER_COUNT" type="USINT" id="13">
  <position x="1" y="35" />
  <comment>
 maximalni pocet zarizeni typu Inverter   </comment>
</inVariable>
<inVariable name="0" type="" id="14">
  <position x="1" y="41" />
  <comment>
 maximalni pocet zarizeni typu StringBox  </comment>
</inVariable>
<inVariable name="0" type="" id="15">
  <position x="1" y="47" />
  <comment>
 maximalni pocet zarizeni typu Battery  </comment>
</inVariable>
<inVariable name="0" type="" id="16">
  <position x="0" y="53" />
  <comment>
 maximalni pocet zarizeni typu Meter  </comment>
</inVariable>
<inVariable name="ADR(DeviceInfo)" type="" id="17">
  <position x="1" y="26" />
</inVariable>
<inVariable name="ADR(Inverter[InverterIdx])" type="" id="18">
  <position x="66" y="27" />
</inVariable>
<node id="19">
  <position x="33" y="17" />
  <connection refid="5">
    <position x="33" y="17" />
    <position x="17" y="17" />
    <position x="17" y="18" />
    <position x="10" y="18" />
  </connection>
</node>
<node id="20">
  <position x="37" y="21" />
  <connection refid="7">
    <position x="37" y="21" />
    <position x="19" y="21" />
    <position x="19" y="24" />
    <position x="5" y="24" />
  </connection>
</node>
<node id="21">
  <position x="35" y="19" />
  <connection refid="6">
    <position x="35" y="19" />
    <position x="17" y="19" />
    <position x="17" y="21" />
    <position x="9" y="21" />
  </connection>
</node>
<block name="fb_SMFini" instance="smFini" id="47" height="6" width="11" line="17" order="4">
  <position x="114" y="12" />
  <inVariables>
    <variable name="__EN" type="BOOL" eneno="true">
      <connection refid="48" name="done">
        <position x="114" y="15" />
        <position x="110" y="15" />
        <position x="110" y="15" />
        <position x="109" y="15" />
      </connection>
    </variable>
  </inVariables>
  <outVariables>
    <variable name="__ENO" type="BOOL" eneno="true">
    </variable>
  </outVariables>
  <inVariables>
    <variable name="tcp" type="BOOL">
      <connection refid="59">
        <position x="114" y="17" />
        <position x="112" y="17" />
        <position x="112" y="8" />
        <position x="91" y="8" />
      </connection>
    <comment>protocol type</comment>
    </variable>
  </inVariables>
</block>
<block name="fb_SMPowerControl" instance="smPc" id="48" height="18" width="15" line="11" order="3">
  <position x="94" y="12" />
  <inVariables>
    <variable name="enable" type="BOOL">
      <connection refid="2" name="Q1">
        <position x="94" y="15" />
        <position x="89" y="15" />
        <position x="89" y="15" />
        <position x="79" y="15" />
      </connection>
    <comment>if enable=0, block is disabled, start with rising edge</comment>
    </variable>
    <variable name="ip" type="STRING[80]">
      <connection refid="19">
        <position x="94" y="17" />
        <position x="93" y="17" />
        <position x="93" y="6" />
        <position x="33" y="6" />
        <position x="33" y="17" />
        <position x="33" y="17" />
      </connection>
    <comment>SM2-MU gateway IP address</comment>
    </variable>
    <variable name="chanCode" type="UINT">
      <connection refid="21">
        <position x="94" y="19" />
        <position x="92" y="19" />
        <position x="92" y="7" />
        <position x="35" y="7" />
        <position x="35" y="19" />
        <position x="35" y="19" />
      </connection>
    <comment>communication channel number</comment>
    </variable>
    <variable name="tcp" type="BOOL">
      <connection refid="59">
        <position x="94" y="21" />
        <position x="91" y="21" />
        <position x="91" y="8" />
        <position x="91" y="8" />
      </connection>
    <comment>protocol type - TRUE = TCP, FALSE = UDP</comment>
    </variable>
    <variable name="read" type="BOOL">
      <connection refid="64">
        <position x="94" y="23" />
        <position x="86" y="23" />
        <position x="86" y="22" />
        <position x="71" y="22" />
      </connection>
    <comment>TRUE - reading, FALSE - writting</comment>
    </variable>
    <variable name="active" type="BOOL">
      <connection refid="62">
        <position x="94" y="25" />
        <position x="86" y="25" />
        <position x="86" y="25" />
        <position x="70" y="25" />
      </connection>
    <comment>TRUE - active power, FALSE - reactive power</comment>
    </variable>
    <variable name="InverterPtr" type="PTR_TO TInverter">
      <connection refid="18">
        <position x="94" y="27" />
        <position x="93" y="27" />
        <position x="93" y="28" />
        <position x="86" y="28" />
      </connection>
    </variable>
  </inVariables>
  <outVariables>
    <variable name="done" type="BOOL">
    <comment>block finished</comment>
    </variable>
    <variable name="busy" type="BOOL">
    <comment>block is still running</comment>
    </variable>
    <variable name="err" type="BOOL">
    <comment>block ended with error</comment>
    </variable>
    <variable name="errCode" type="USINT">
    <comment>error code</comment>
    </variable>
    <variable name="errTxt" type="STRING[80]">
    <comment>error report</comment>
    </variable>
  </outVariables>
  <inOutVariables>
    <variable name="pwctrl" type="INT">
      <connection refid="66">
        <position x="94" y="29" />
        <position x="93" y="29" />
        <position x="93" y="57" />
        <position x="11" y="57" />
      </connection>
    <comment>set/read power value {CSY } nastavovana / prectena hodnota vykonu</comment>
    </variable>
  </inOutVariables>
</block>
<node id="59">
  <position x="91" y="8" />
  <connection refid="20">
    <position x="91" y="8" />
    <position x="37" y="8" />
    <position x="37" y="21" />
    <position x="37" y="21" />
  </connection>
</node>
<inVariable name="true" type="BOOL" id="62">
  <position x="66" y="24" />
</inVariable>
<inVariable name="false" type="BOOL" id="64">
  <position x="66" y="21" />
</inVariable>
<inVariable name="pwctrl_value" type="UINT" id="66">
  <position x="0" y="56" />
  <comment>
pozadovana hodnota vykonu [%]  </comment>
</inVariable>
</fbd>
{/NOCODE}
//LVD
VAR
(*  20	*)	_Tmp_For_Back_Conn_1	:	BOOL;
END_VAR

//TVD
VAR_TEMP
(* 242	*)	_Nod_Tmp_3	:	STRING[80];
(* 260	*)	_Nod_Tmp_2	:	UINT;
(* 251	*)	_Nod_Tmp_1	:	BOOL;
END_VAR

//NC
//N000
(* 192	*)	LD 	IP_Address
(* 242	*)	ST	_Nod_Tmp_3
(* 195	*)	LD 	chanCode
(* 260	*)	ST	_Nod_Tmp_2
(* 198	*)	LD 	tcp
(* 251	*)	ST	_Nod_Tmp_1
(*  35	*)	CAL	smInit(enable:=smInit_enable, ip:=_Nod_Tmp_3, chanCode:=_Nod_Tmp_2, tcp:=_Nod_Tmp_1, DevInfoPtr:=ADR(DeviceInfo), DevInfoSize:=DEVICE_COUNT, InverterPtr:=ADR(Inverter), InverterCount:=INVERTER_COUNT, StringBoxPtr:=0, StringBoxCount:=0, BatteryPtr:=0, BatteryCount:=0, MeterPtr:=0, MeterCount:=0)
(*   8	*)	CAL	pc_SR(S1:=smInit.done, R:=_Tmp_For_Back_Conn_1)
(* 297	*)	CAL	smPc(enable:=pc_SR.Q1, ip:=_Nod_Tmp_3, chanCode:=_Nod_Tmp_2, tcp:=_Nod_Tmp_1, read:=false, active:=true, InverterPtr:=ADR(Inverter[InverterIdx]), pwctrl:=void(pwctrl_value))
(* 297	*)	LD 	smPc.done
{CREATE_TEMP=__TmpEn_0}
(* 273	*)	ST	__TmpEn_0
(* 273	*)	LD	__TmpEn_0
(* 273	*)	JMPCN __PouSkip_0_1
(* 269	*)	CAL	smFini(tcp:=_Nod_Tmp_1)
			__PouSkip_0_1:
//N001
(*  20	*)	ST	_Tmp_For_Back_Conn_1

END_PROGRAM
