(* Upozornen *)
(* Soubor je automaticky regenerovn a vechny rucn modifikace budou ztracen. *)

VAR_GLOBAL CONSTANT
   CPU_TYPE : USINT := 76; (* CPU type *)
   CPU_CODE : UINT := 1003; (* CPU code *)
END_VAR

TYPE

   TBIN_16DI : STRUCT
      DI0 : BOOL;
      DI1 : BOOL;
      DI2 : BOOL;
      DI3 : BOOL;
      DI4 : BOOL;
      DI5 : BOOL;
      DI6 : BOOL;
      DI7 : BOOL;
      DI8 : BOOL;
      DI9 : BOOL;
      DI10 : BOOL;
      DI11 : BOOL;
      DI12 : BOOL;
      DI13 : BOOL;
      DI14 : BOOL;
      DI15 : BOOL;
   END_STRUCT;

   TBIN_8DIP16 : STRUCT
      dummy0 {HIDDEN} : BOOL;
      dummy1 {HIDDEN} : BOOL;
      dummy2 {HIDDEN} : BOOL;
      dummy3 {HIDDEN} : BOOL;
      dummy4 {HIDDEN} : BOOL;
      dummy5 {HIDDEN} : BOOL;
      dummy6 {HIDDEN} : BOOL;
      dummy7 {HIDDEN} : BOOL;
      DIP8 : BOOL;
      DIP9 : BOOL;
      DIP10 : BOOL;
      DIP11 : BOOL;
      DIP12 : BOOL;
      DIP13 : BOOL;
      DIP14 : BOOL;
      DIP15 : BOOL;
   END_STRUCT;

   TCNTF_IN : STRUCT
      SCNT : UINT;
      VALA : UDINT;
      VALB : UDINT;
   END_STRUCT;

   TAIStat : STRUCT
      UNF : BOOL;
      UNR : BOOL;
      OVR : BOOL;
      OVF : BOOL;
      FLS : BOOL;
      CJC : BOOL;
      dummy6 {HIDDEN} : BOOL;
      dummy7 {HIDDEN} : BOOL;
      CHC : BOOL;
      dummy9 {HIDDEN} : BOOL;
      dummy10 {HIDDEN} : BOOL;
      dummy11 {HIDDEN} : BOOL;
      dummy12 {HIDDEN} : BOOL;
      dummy13 {HIDDEN} : BOOL;
      dummy14 {HIDDEN} : BOOL;
      dummy15 {HIDDEN} : BOOL;
   END_STRUCT;

   TAI : STRUCT
      STAT : TAIStat;
      FS : INT;
      ENG : REAL;
      PCT : REAL;
   END_STRUCT;

   TMC_IN : STRUCT
      MCSTAT : USINT;
      MCERR : USINT;
      MCPOS : DINT;
      MCVEL : UDINT;
   END_STRUCT;

   TBIN_12DOE : STRUCT
      DO0 : BOOL;
      DO1 : BOOL;
      DO2 : BOOL;
      DO3 : BOOL;
      DO4 : BOOL;
      DO5 : BOOL;
      DO6 : BOOL;
      DO7 : BOOL;
      DO8 : BOOL;
      DO9 : BOOL;
      DO10 : BOOL;
      DO11 : BOOL;
      dummy12 {HIDDEN} : BOOL;
      dummy13 {HIDDEN} : BOOL;
      ENA : BOOL;
      ENB : BOOL;
   END_STRUCT;

   TCNTF2_OUT : STRUCT
      CCNT : UINT;
      SET : UDINT;
      SETB : UDINT;
   END_STRUCT;

   TAO : STRUCT
      FS : INT;
      ENG : REAL;
      PCT : REAL;
   END_STRUCT;

   TPWM : STRUCT
      FS : INT;
      PCT : REAL;
   END_STRUCT;

   TMC_OUT : STRUCT
      MCCONT : USINT;
      MCCOMM : USINT;
      MCPAR1 : UDINT;
      MCPAR2 : DINT;
   END_STRUCT;

   TCHStatistic : STRUCT
      STAT : USINT;
      ERR : USINT;
      trueMes : UDINT;
      falseMes : UDINT;
   END_STRUCT;

   TUniStat : STRUCT
      DSR : BOOL;
      CTS : BOOL;
      dummy2 {HIDDEN} : BOOL;
      TRO : BOOL;
      RCF : BOOL;
      ROV : BOOL;
      TRF : BOOL;
      ARC : BOOL;
   END_STRUCT;

   TZONE_ARRAY_ETH1_UNI0_RX : ARRAY[0..249] OF USINT;

   TUNI_ETH1_UNI0_IN : STRUCT
      STAT : TUniStat;
      ERR : USINT;
      NUMR : UINT;
      DATA : TZONE_ARRAY_ETH1_UNI0_RX;
   END_STRUCT;

   TCHControl : STRUCT
      CONTROL : UINT;
   END_STRUCT;

   TUniCont : STRUCT
      dummy0 {HIDDEN} : BOOL;
      dummy1 {HIDDEN} : BOOL;
      dummy2 {HIDDEN} : BOOL;
      dummy3 {HIDDEN} : BOOL;
      dummy4 {HIDDEN} : BOOL;
      TRG : BOOL;
      CLR : BOOL;
      ACN : BOOL;
   END_STRUCT;

   TUniSign : STRUCT
      DTR : BOOL;
      RTS : BOOL;
      dummy2 {HIDDEN} : BOOL;
      dummy3 {HIDDEN} : BOOL;
      dummy4 {HIDDEN} : BOOL;
      dummy5 {HIDDEN} : BOOL;
      dummy6 {HIDDEN} : BOOL;
      dummy7 {HIDDEN} : BOOL;
   END_STRUCT;

   TZONE_ARRAY_ETH1_UNI0_TX : ARRAY[0..249] OF USINT;

   TUNI_ETH1_UNI0_OUT : STRUCT
      CONT : TUniCont;
      SIGN : TUniSign;
      NUMT : UINT;
      DATA : TZONE_ARRAY_ETH1_UNI0_TX;
   END_STRUCT;

END_TYPE

VAR_GLOBAL_INPUT
(* IR-1062 *)
   r0_p3_DI : TBIN_16DI;
   r0_p3_DIP : TBIN_8DIP16;
   r0_p3_CNT_IN1 : TCNTF_IN;
   r0_p3_CNT_IN2 : TCNTF_IN;
   r0_p3_AI0 : TAI;
   r0_p3_AI1 : TAI;
   r0_p3_AI2 : TAI;
   r0_p3_AI3 : TAI;
   r0_p3_AI4 : TAI;
   r0_p3_AI5 : TAI;
   r0_p3_AI6 : TAI;
   r0_p3_AI7 : TAI;
   r0_p3_MC_IN1 : TMC_IN;
   r0_p3_MC_IN2 : TMC_IN;
(* ETH1_UNI0 *)
   r0_p0_Statistic_ETH1_UNI0 : TCHStatistic;
   UNI_ETH1_UNI0_IN : TUNI_ETH1_UNI0_IN;
END_VAR

VAR_GLOBAL_OUTPUT
(* IR-1062 *)
   r0_p3_DO : TBIN_12DOE;
   r0_p3_CNT_OUT1 : TCNTF2_OUT;
   r0_p3_CNT_OUT2 : TCNTF2_OUT;
   r0_p3_AO0 : TAO;
   r0_p3_AO1 : TAO;
   r0_p3_AO2 : TAO;
   r0_p3_AO3 : TAO;
   r0_p3_PWM8 : TPWM;
   r0_p3_PWM9 : TPWM;
   r0_p3_PWM10 : TPWM;
   r0_p3_PWM11 : TPWM;
   r0_p3_MC_OUT1 : TMC_OUT;
   r0_p3_MC_OUT2 : TMC_OUT;
(* ETH1_UNI0 *)
   r0_p0_Control_ETH1_UNI0 : TCHControl;
   UNI_ETH1_UNI0_OUT : TUNI_ETH1_UNI0_OUT;
END_VAR

VAR_GLOBAL
END_VAR

VAR_EXTERNAL
END_VAR



(* ******************************************************************************* *)
(* Generovno programem Mosaic *)
(*  2001-2021 Teco a.s. *)
