PROGRAM prgMain
  VAR CONSTANT
    IP_Address      : STRING := '192.168.1.125:502';
    chanCode        : UINT   := ETH1_uni0;
    tcp             : BOOL   := true;

    slaveID : USINT := 1; (*logicke id zarizeni v SM2-MU, kteremu nastavujeme vykon
                            (zde musi byt Xtender, protoze pracujeme s parametrem 1297)*)
    PARAM_COUNT : INT := 6; (* pocet parametru *)
    DEVICE_COUNT : USINT  := 7;
  END_VAR

  VAR_INPUT
  END_VAR
  VAR_OUTPUT
  END_VAR
  VAR
    smInit : fb_SMInit;
    smInit_enable : BOOL := true;
    smFini : fb_SMFini;
    DeviceInfo : ARRAY [1..DEVICE_COUNT]    OF TDeviceBlockInfo; (*Informace o blocich v jednotlivych zarizenich*)
    par_SR : SR;
    smPar : fb_SMReadWriteParameter;
    params : ARRAY [0 .. PARAM_COUNT(*-1*)] OF TParams := [
    (id := 1108, pType := PARAM_FLOAT, cmd := PARAM_READ),
    (id := 1121, pType := PARAM_FLOAT, cmd := PARAM_READ),
    (id := 1143, pType := PARAM_FLOAT, cmd := PARAM_READ),
    (id := 1297, pType := PARAM_FLOAT, cmd := PARAM_READ),
    (id := 1298, pType := PARAM_FLOAT, cmd := PARAM_READ),
    (id := 1307, pType := PARAM_FLOAT, cmd := PARAM_READ)
    ];
    i : INT := 1;
    delay_SR : SR;
    delay : TON;
    counter : CTU;
    delay_ET : TIME;
  END_VAR
  VAR_TEMP
  END_VAR
{NOCODE}
<?xml version="1.0" encoding="windows-1250" ?>
<?xml-stylesheet type="text/xsl" href="pokus.xsl" version="1.1"?>
<fbd version="1.1">
<comment id="1" height="3" width="12">
  <position x="3" y="5" />
Schema comment
</comment>
<block name="fb_SMInit" instance="smInit" id="2" height="30" width="20" line="30" order="7">
  <position x="41" y="12" />
  <inVariables>
    <variable name="enable" type="BOOL">
      <connection refid="3">
        <position x="41" y="15" />
        <position x="18" y="15" />
        <position x="18" y="15" />
        <position x="12" y="15" />
      </connection>
    <comment>if enable=0, block is disabled, start with rising edge</comment>
    </variable>
    <variable name="ip" type="STRING[80]">
      <connection refid="95">
        <position x="41" y="17" />
        <position x="40" y="17" />
        <position x="40" y="17" />
        <position x="35" y="17" />
      </connection>
    <comment>SM2-MU gateway IP address</comment>
    </variable>
    <variable name="chanCode" type="UINT">
      <connection refid="99">
        <position x="41" y="19" />
        <position x="39" y="19" />
        <position x="39" y="19" />
        <position x="37" y="19" />
      </connection>
    <comment>communication channel number</comment>
    </variable>
    <variable name="tcp" type="BOOL">
      <connection refid="103">
        <position x="41" y="21" />
        <position x="40" y="21" />
        <position x="40" y="21" />
        <position x="39" y="21" />
      </connection>
    <comment>protocol type - TRUE = TCP, FALSE = UDP</comment>
    </variable>
    <variable name="DevInfoPtr" type="PTR_TO TDeviceBlockInfo">
      <connection refid="16">
        <position x="41" y="23" />
        <position x="21" y="23" />
        <position x="21" y="27" />
        <position x="14" y="27" />
      </connection>
    <comment>pointer to array start</comment>
    </variable>
    <variable name="DevInfoSize" type="USINT">
      <connection refid="7">
        <position x="41" y="25" />
        <position x="23" y="25" />
        <position x="23" y="30" />
        <position x="13" y="30" />
      </connection>
    <comment>max. number of devices (array size)</comment>
    </variable>
    <variable name="InverterPtr" type="PTR_TO TInverter">
      <connection refid="8">
        <position x="41" y="27" />
        <position x="25" y="27" />
        <position x="25" y="33" />
        <position x="3" y="33" />
      </connection>
    <comment>Pointer to array of Inverter structures</comment>
    </variable>
    <variable name="InverterCount" type="USINT">
      <connection refid="12">
        <position x="41" y="29" />
        <position x="27" y="29" />
        <position x="27" y="36" />
        <position x="3" y="36" />
      </connection>
    <comment>max. number of Inverters (array size)</comment>
    </variable>
    <variable name="StringBoxPtr" type="PTR_TO TStringBox">
      <connection refid="9">
        <position x="41" y="31" />
        <position x="29" y="31" />
        <position x="29" y="39" />
        <position x="3" y="39" />
      </connection>
    <comment>Pointer to array of StringBox structures</comment>
    </variable>
    <variable name="StringBoxCount" type="USINT">
      <connection refid="13">
        <position x="41" y="33" />
        <position x="31" y="33" />
        <position x="31" y="42" />
        <position x="3" y="42" />
      </connection>
    <comment>max. number of Inverters (array size)</comment>
    </variable>
    <variable name="BatteryPtr" type="PTR_TO TBattery">
      <connection refid="10">
        <position x="41" y="35" />
        <position x="33" y="35" />
        <position x="33" y="45" />
        <position x="3" y="45" />
      </connection>
    <comment>Pointer to array of Battery structures</comment>
    </variable>
    <variable name="BatteryCount" type="USINT">
      <connection refid="14">
        <position x="41" y="37" />
        <position x="35" y="37" />
        <position x="35" y="48" />
        <position x="3" y="48" />
      </connection>
    <comment>max. number of Batteries (array size)</comment>
    </variable>
    <variable name="MeterPtr" type="PTR_TO TMeter">
      <connection refid="11">
        <position x="41" y="39" />
        <position x="37" y="39" />
        <position x="37" y="51" />
        <position x="3" y="51" />
      </connection>
    <comment>Pointer to array of Meter structures</comment>
    </variable>
    <variable name="MeterCount" type="USINT">
      <connection refid="15">
        <position x="41" y="41" />
        <position x="39" y="41" />
        <position x="39" y="54" />
        <position x="3" y="54" />
      </connection>
    <comment>max. number of Meters (array size)</comment>
    </variable>
  </inVariables>
  <outVariables>
    <variable name="done" type="BOOL">
    <comment>block finished</comment>
    </variable>
    <variable name="busy" type="BOOL">
    <comment>block is still running</comment>
    </variable>
    <variable name="err" type="BOOL">
    <comment>block ended with error</comment>
    </variable>
    <variable name="errCode" type="USINT">
    <comment>error code</comment>
    </variable>
    <variable name="errTxt" type="STRING[80]">
    <comment>error report</comment>
    </variable>
    <variable name="devCount" type="USINT">
    <comment>number of devices in the SM2-MU gateway</comment>
    </variable>
    <variable name="DevTypeCount" type="TDeviceTypeCount">
    <comment>structure with count of each device type</comment>
    </variable>
  </outVariables>
</block>
<inVariable name="smInit_enable" type="BOOL" id="3">
  <position x="1" y="14" />
</inVariable>
<inVariable name="IP_Address" type="STRING" id="4">
  <position x="1" y="17" />
</inVariable>
<inVariable name="chanCode" type="UINT" id="5">
  <position x="1" y="20" />
</inVariable>
<inVariable name="tcp" type="BOOL" id="6">
  <position x="1" y="23" />
</inVariable>
<inVariable name="DEVICE_COUNT" type="USINT" id="7">
  <position x="1" y="29" />
</inVariable>
<inVariable name="0" type="" id="8">
  <position x="1" y="32" />
</inVariable>
<inVariable name="0" type="" id="9">
  <position x="0" y="38" />
</inVariable>
<inVariable name="0" type="" id="10">
  <position x="1" y="44" />
</inVariable>
<inVariable name="0" type="" id="11">
  <position x="1" y="50" />
</inVariable>
<inVariable name="0" type="" id="12">
  <position x="1" y="35" />
  <comment>
 maximalni pocet zarizeni typu Inverter   </comment>
</inVariable>
<inVariable name="0" type="" id="13">
  <position x="1" y="41" />
  <comment>
 maximalni pocet zarizeni typu StringBox  </comment>
</inVariable>
<inVariable name="0" type="" id="14">
  <position x="0" y="47" />
  <comment>
 maximalni pocet zarizeni typu Battery  </comment>
</inVariable>
<inVariable name="0" type="" id="15">
  <position x="1" y="53" />
  <comment>
 maximalni pocet zarizeni typu Meter  </comment>
</inVariable>
<inVariable name="ADR(DeviceInfo)" type="" id="16">
  <position x="1" y="26" />
</inVariable>
<block name="fb_SMFini" instance="smFini" id="32" height="6" width="10" line="24" order="6">
  <position x="103" y="48" />
  <inVariables>
    <variable name="__EN" type="BOOL" eneno="true">
      <connection refid="81">
        <position x="103" y="51" />
        <position x="101" y="51" />
        <position x="101" y="51" />
        <position x="76" y="51" />
      </connection>
    </variable>
  </inVariables>
  <outVariables>
    <variable name="__ENO" type="BOOL" eneno="true">
    </variable>
  </outVariables>
  <inVariables>
    <variable name="tcp" type="BOOL">
      <connection refid="109">
        <position x="103" y="53" />
        <position x="101" y="53" />
        <position x="101" y="45" />
        <position x="122" y="45" />
        <position x="122" y="7" />
        <position x="94" y="7" />
      </connection>
    <comment>protocol type</comment>
    </variable>
  </inVariables>
</block>
<block name="SR" instance="par_SR" id="33" height="6" width="6" line="37" order="10">
  <position x="80" y="12" />
  <inVariables>
    <variable name="S1" type="BOOL">
      <connection refid="36" name="OR">
        <position x="80" y="15" />
        <position x="79" y="15" />
        <position x="79" y="15" />
        <position x="76" y="15" />
      </connection>
    </variable>
    <variable name="R" type="BOOL">
      <connection refid="91">
        <position x="80" y="17" />
        <position x="78" y="17" />
        <position x="78" y="9" />
        <position x="119" y="9" />
        <position x="119" y="15" />
        <position x="119" y="15" />
      </connection>
    </variable>
  </inVariables>
  <outVariables>
    <variable name="Q1" type="BOOL">
    </variable>
  </outVariables>
</block>
<block name="fb_SMReadWriteParameter" instance="smPar" id="34" height="14" width="19" line="38" order="11">
  <position x="98" y="12" />
  <inVariables>
    <variable name="enable" type="BOOL">
      <connection refid="33" name="Q1">
        <position x="98" y="15" />
        <position x="94" y="15" />
        <position x="94" y="15" />
        <position x="86" y="15" />
      </connection>
    <comment>if enable=0, block is disabled, start with rising edge</comment>
    </variable>
    <variable name="ip" type="STRING[80]">
      <connection refid="95">
        <position x="98" y="17" />
        <position x="96" y="17" />
        <position x="96" y="5" />
        <position x="35" y="5" />
        <position x="35" y="17" />
        <position x="35" y="17" />
      </connection>
    <comment>SM2-MU gateway IP address</comment>
    </variable>
    <variable name="chanCode" type="UINT">
      <connection refid="99">
        <position x="98" y="19" />
        <position x="95" y="19" />
        <position x="95" y="6" />
        <position x="37" y="6" />
        <position x="37" y="19" />
        <position x="37" y="19" />
      </connection>
    <comment>communication channel number</comment>
    </variable>
    <variable name="tcp" type="BOOL">
      <connection refid="109">
        <position x="98" y="21" />
        <position x="94" y="21" />
        <position x="94" y="7" />
        <position x="94" y="7" />
      </connection>
    <comment>protocol type - TRUE = TCP, FALSE = UDP</comment>
    </variable>
    <variable name="DevInfoPtr" type="PTR_TO TDeviceBlockInfo">
      <connection refid="59">
        <position x="98" y="23" />
        <position x="94" y="23" />
        <position x="94" y="23" />
        <position x="92" y="23" />
      </connection>
    <comment>pointer to array item (contains also device address)</comment>
    </variable>
  </inVariables>
  <outVariables>
    <variable name="done" type="BOOL">
    <comment>block finished</comment>
    </variable>
    <variable name="busy" type="BOOL">
    <comment>block is still running</comment>
    </variable>
    <variable name="err" type="BOOL">
    <comment>block ended with error</comment>
    </variable>
    <variable name="errCode" type="USINT">
    <comment>error code</comment>
    </variable>
  </outVariables>
  <inOutVariables>
    <variable name="params" type="TParams">
      <connection refid="61">
        <position x="98" y="25" />
        <position x="94" y="25" />
        <position x="94" y="26" />
        <position x="81" y="26" />
      </connection>
    <comment>Structure of read/write Modbus Sunspec parameter block</comment>
    </variable>
  </inOutVariables>
</block>
<block name="AND" instance="" function="true" extensible="true" hiddenPins="true" operator="true" id="35" height="4" width="4" line="32" order="8">
  <position x="68" y="16" />
  <inVariables>
    <variable name="IN1" type="ANY_BIT">
      <connection refid="72">
        <position x="68" y="17" />
        <position x="66" y="17" />
        <position x="66" y="32" />
        <position x="66" y="32" />
      </connection>
    </variable>
    <variable name="IN2" type="ANY_BIT" negated="true">
      <connection refid="81">
        <position x="68" y="19" />
        <position x="64" y="19" />
        <position x="64" y="45" />
        <position x="76" y="45" />
        <position x="76" y="51" />
        <position x="76" y="51" />
      </connection>
    </variable>
  </inVariables>
  <outVariables>
    <variable name="AND" type="ANY_BIT">
    <comment>
	Bitwise AND
	compares every bits on same position in IN1, IN2, ... and generates a 1 result
	if all bits are 1, otherwise it returns 0
</comment>
    </variable>
  </outVariables>
</block>
<block name="OR" instance="" function="true" extensible="true" hiddenPins="true" operator="true" id="36" height="4" width="3" line="35" order="9">
  <position x="73" y="14" />
  <inVariables>
    <variable name="IN1" type="ANY_BIT">
      <connection refid="2" name="done">
        <position x="73" y="15" />
        <position x="70" y="15" />
        <position x="70" y="15" />
        <position x="61" y="15" />
      </connection>
    </variable>
    <variable name="IN2" type="ANY_BIT">
      <connection refid="35" name="AND">
        <position x="73" y="17" />
        <position x="72" y="17" />
        <position x="72" y="17" />
        <position x="73" y="17" />
        <position x="73" y="17" />
        <position x="72" y="17" />
      </connection>
    </variable>
  </inVariables>
  <outVariables>
    <variable name="OR" type="ANY_BIT">
    <comment>
	Bitwise OR
	compares every bits on same position in IN1, IN2, ... and generates a 1 result
	if either or all bits are 1, otherwise it returns 0
</comment>
    </variable>
  </outVariables>
</block>
<block name="SR" instance="delay_SR" id="47" height="6" width="6" line="13" order="3">
  <position x="69" y="35" />
  <inVariables>
    <variable name="S1" type="BOOL">
      <connection refid="87">
        <position x="69" y="38" />
        <position x="68" y="38" />
        <position x="68" y="38" />
        <position x="69" y="38" />
        <position x="69" y="38" />
        <position x="68" y="38" />
      </connection>
    </variable>
    <variable name="R" type="BOOL">
      <connection refid="72">
        <position x="69" y="40" />
        <position x="66" y="40" />
        <position x="66" y="32" />
        <position x="66" y="32" />
      </connection>
    </variable>
  </inVariables>
  <outVariables>
    <variable name="Q1" type="BOOL">
    </variable>
  </outVariables>
</block>
<block name="TON" instance="delay" id="48" height="6" width="6" line="14" order="4">
  <position x="84" y="35" />
  <inVariables>
    <variable name="IN" type="BOOL">
      <connection refid="47" name="Q1">
        <position x="84" y="38" />
        <position x="83" y="38" />
        <position x="83" y="38" />
        <position x="75" y="38" />
      </connection>
    <comment>input</comment>
    </variable>
    <variable name="PT" type="TIME">
      <connection refid="50">
        <position x="84" y="40" />
        <position x="83" y="40" />
        <position x="83" y="40" />
        <position x="82" y="40" />
      </connection>
    <comment>preset</comment>
    </variable>
  </inVariables>
  <outVariables>
    <variable name="Q" type="BOOL">
    <comment>output</comment>
    </variable>
    <variable name="ET" type="TIME">
    <comment>value</comment>
    </variable>
  </outVariables>
</block>
<block name="CTU" instance="counter" id="49" height="8" width="6" line="6" order="1">
  <position x="69" y="48" />
  <inVariables>
    <variable name="CU" type="BOOL R_EDGE">
      <connection refid="87">
        <position x="69" y="51" />
        <position x="68" y="51" />
        <position x="68" y="38" />
        <position x="68" y="38" />
      </connection>
    <comment>up</comment>
    </variable>
    <variable name="R" type="BOOL">
    <comment>reset</comment>
    </variable>
    <variable name="PV" type="INT">
      <connection refid="57">
        <position x="69" y="55" />
        <position x="63" y="55" />
        <position x="63" y="57" />
        <position x="13" y="57" />
      </connection>
    <comment>preset</comment>
    </variable>
  </inVariables>
  <outVariables>
    <variable name="Q" type="BOOL">
    <comment>output</comment>
    </variable>
    <variable name="CV" type="INT">
    <comment>value</comment>
    </variable>
  </outVariables>
</block>
<inVariable name="T#1ms" type="TIME" id="50">
  <position x="76" y="39" />
</inVariable>
<outVariable name="delay_ET" type="TIME" id="52" order="5">
  <position x="103" y="39" />
  <connection refid="48" name="ET">
    <position x="104" y="40" />
    <position x="91" y="40" />
    <position x="91" y="40" />
    <position x="90" y="40" />
  </connection>
</outVariable>
<inVariable name="PARAM_COUNT" type="INT" id="57">
  <position x="1" y="56" />
  <comment>
 pocet parametru   </comment>
</inVariable>
<inVariable name="ADR(DeviceInfo[slaveID])" type="" id="59">
  <position x="73" y="22" />
</inVariable>
<inVariable name="params[i]" type="TParams" id="61">
  <position x="73" y="25" />
  <comment>
-1  </comment>
</inVariable>
<outVariable name="i" type="INT" id="63" order="2">
  <position x="84" y="52" />
  <connection refid="49" name="CV">
    <position x="85" y="53" />
    <position x="84" y="53" />
    <position x="84" y="53" />
    <position x="75" y="53" />
  </connection>
</outVariable>
<node id="72">
  <position x="66" y="32" />
  <connection refid="48" name="Q">
    <position x="66" y="32" />
    <position x="91" y="32" />
    <position x="91" y="38" />
    <position x="90" y="38" />
  </connection>
</node>
<node id="81">
  <position x="76" y="51" />
  <connection refid="49" name="Q">
    <position x="76" y="51" />
    <position x="75" y="51" />
    <position x="75" y="51" />
    <position x="76" y="51" />
    <position x="76" y="51" />
    <position x="75" y="51" />
  </connection>
</node>
<node id="87">
  <position x="68" y="38" />
  <connection refid="91">
    <position x="68" y="38" />
    <position x="68" y="38" />
    <position x="68" y="30" />
    <position x="119" y="30" />
    <position x="119" y="15" />
    <position x="119" y="15" />
  </connection>
</node>
<node id="91">
  <position x="119" y="15" />
  <connection refid="34" name="done">
    <position x="119" y="15" />
    <position x="118" y="15" />
    <position x="118" y="15" />
    <position x="117" y="15" />
  </connection>
</node>
<node id="95">
  <position x="35" y="17" />
  <connection refid="4">
    <position x="35" y="17" />
    <position x="17" y="17" />
    <position x="17" y="18" />
    <position x="10" y="18" />
  </connection>
</node>
<node id="99">
  <position x="37" y="19" />
  <connection refid="5">
    <position x="37" y="19" />
    <position x="17" y="19" />
    <position x="17" y="21" />
    <position x="9" y="21" />
  </connection>
</node>
<node id="103">
  <position x="39" y="21" />
  <connection refid="6">
    <position x="39" y="21" />
    <position x="19" y="21" />
    <position x="19" y="24" />
    <position x="5" y="24" />
  </connection>
</node>
<node id="109">
  <position x="94" y="7" />
  <connection refid="103">
    <position x="94" y="7" />
    <position x="39" y="7" />
    <position x="39" y="21" />
    <position x="39" y="21" />
  </connection>
</node>
</fbd>
{/NOCODE}
//LVD
VAR
(* 254	*)	_Tmp_For_Back_Conn_4	:	BOOL;
(* 560	*)	_Tmp_For_Back_Conn_3	:	BOOL;
(* 540	*)	_Tmp_For_Back_Conn_2	:	BOOL;
(* 360	*)	_Tmp_For_Back_Conn_1	:	BOOL;
END_VAR

//TVD
VAR_TEMP
(* 558	*)	_Nod_Tmp_9	:	BOOL;
(* 538	*)	_Nod_Tmp_8	:	BOOL;
(* 596	*)	_Nod_Tmp_7	:	BOOL;
(* 578	*)	_Nod_Tmp_6	:	STRING[80];
(* 587	*)	_Nod_Tmp_5	:	UINT;
(* 380	*)	_Fun_Tmp_IN2_3_2	:	BOOL;
(* 569	*)	_Nod_Tmp_2	:	BOOL;
(* 547	*)	_Nod_Tmp_1	:	BOOL;
END_VAR

//NC
//N002
(* 560	*)	LD	_Tmp_For_Back_Conn_3
//N000
(* 558	*)	ST	_Nod_Tmp_9
(* 470	*)	CAL	counter(CU:=_Nod_Tmp_9, PV:=PARAM_COUNT)
(* 470	*)	LD 	counter.CV
(* 529	*)	ST 	i
//N004
(* 540	*)	LD	_Tmp_For_Back_Conn_2
//N000
(* 538	*)	ST	_Nod_Tmp_8
(* 412	*)	CAL	delay_SR(S1:=_Nod_Tmp_9, R:=_Nod_Tmp_8)
(* 439	*)	CAL	delay(IN:=delay_SR.Q1, PT:=T#1ms)
(* 439	*)	LD 	delay.ET
(* 507	*)	ST 	delay_ET
(* 470	*)	LD 	counter.Q
{CREATE_TEMP=__TmpEn_0}
(* 549	*)	ST	__TmpEn_0
(* 171	*)	LD 	tcp
(* 596	*)	ST	_Nod_Tmp_7
(* 216	*)	LD	__TmpEn_0
(* 216	*)	JMPCN __PouSkip_0_1
(* 212	*)	CAL	smFini(tcp:=_Nod_Tmp_7)
			__PouSkip_0_1:
(* 165	*)	LD 	IP_Address
(* 578	*)	ST	_Nod_Tmp_6
(* 168	*)	LD 	chanCode
(* 587	*)	ST	_Nod_Tmp_5
(*   8	*)	CAL	smInit(enable:=smInit_enable, ip:=_Nod_Tmp_6, chanCode:=_Nod_Tmp_5, tcp:=_Nod_Tmp_7, DevInfoPtr:=ADR(DeviceInfo), DevInfoSize:=DEVICE_COUNT, InverterPtr:=0, InverterCount:=0, StringBoxPtr:=0, StringBoxCount:=0, BatteryPtr:=0, BatteryCount:=0, MeterPtr:=0, MeterCount:=0)
(* 352	*)	LD 	_Nod_Tmp_8
(* 360	*)	ANDN	_Tmp_For_Back_Conn_1
(* 392	*)	ST 	_Fun_Tmp_IN2_3_2
(* 384	*)	LD 	smInit.done
(* 392	*)	OR 	_Fun_Tmp_IN2_3_2
(* 242	*)	ST 	par_SR.S1
(* 242	*)	CAL	par_SR(R:=_Tmp_For_Back_Conn_4)
(* 269	*)	CAL	smPar(enable:=par_SR.Q1, ip:=_Nod_Tmp_6, chanCode:=_Nod_Tmp_5, tcp:=_Nod_Tmp_7, DevInfoPtr:=ADR(DeviceInfo[slaveID]), params:=void(params[i]))
(* 269	*)	LD 	smPar.done
(* 569	*)	ST	_Nod_Tmp_2
//N001
(* 254	*)	ST	_Tmp_For_Back_Conn_4
//N000
(* 569	*)	LD	_Nod_Tmp_2
//N002
(* 560	*)	ST	_Tmp_For_Back_Conn_3
//N000
(* 439	*)	LD 	delay.Q
//N004
(* 540	*)	ST	_Tmp_For_Back_Conn_2
//N000
(* 549	*)	LD	__TmpEn_0
(* 547	*)	ST	_Nod_Tmp_1
//N005
(* 360	*)	ST	_Tmp_For_Back_Conn_1

END_PROGRAM
