PROGRAM prgMain
  VAR CONSTANT
    IP_Address      : STRING := '192.168.1.125:502';
    chanCode        : UINT   := ETH1_uni0;
    tcp             : BOOL   := true;

    InverterIdx : USINT := 1; (*logicke id zarizeni, pro ktere nastavujeme vykon*)
    INVERTER_COUNT  : USINT := 4; (* maximalni pocet zarizeni typu Inverter *)
    DEVICE_COUNT : USINT := INVERTER_COUNT;
    PERIOD_TIME_FULL_POWER : TIME := T#10s;
    PERIOD_TIME_LOWER_POWER : TIME := T#5s;
  END_VAR

  VAR_INPUT
  END_VAR
  VAR_OUTPUT
  END_VAR
  VAR
    smInit : fb_SMInit;
    smInit_enable : BOOL := true;
    DeviceInfo : ARRAY [1..DEVICE_COUNT]    OF TDeviceBlockInfo; (*Informace o blocich v jednotlivych zarizenich*)
    Inverter   : ARRAY [1..INVERTER_COUNT]  OF TInverter;
    pcRead_SR : SR;
    smPcRead : fb_SMPowerControl;
    pwctrl_val_read : UINT := 60; (*pozadovana hodnota vykonu [%]*)
    idx : INT := 0;
    pwrctrl: ARRAY [0..1+1] OF pwctrlStructure := [
                                                  (val := 60,  period := PERIOD_TIME_FULL_POWER),
                                                  (val := 100, period := PERIOD_TIME_LOWER_POWER),
                                                  (period := PERIOD_TIME_FULL_POWER)
                                                  ]; (*hodnota period je vzdy pro nasledujici stav*)
    pcWrite_SR : SR;
    smPcWrite : fb_SMPowerControl;
    timer_SR : SR;
    timer : TON;
    timer_ET : TIME;
    counter : CTU;
  END_VAR
  VAR_TEMP
  END_VAR
{NOCODE}
<?xml version="1.0" encoding="windows-1250" ?>
<?xml-stylesheet type="text/xsl" href="cfc.xsl" version="1.1"?>
<fbd version="1.1" grid="8">
<comment id="1" height="3" width="12">
  <position x="3" y="5" />
Schema comment
</comment>
<block name="fb_SMInit" instance="smInit" id="2" height="30" width="16" line="20" order="4">
  <position x="41" y="12" />
  <inVariables>
    <variable name="enable" type="BOOL">
      <connection refid="3">
        <position x="41" y="15" />
        <position x="18" y="15" />
        <position x="18" y="15" />
        <position x="10" y="15" />
      </connection>
    <comment>if enable=0, block is disabled, start with rising edge</comment>
    </variable>
    <variable name="ip" type="STRING[80]">
      <connection refid="17">
        <position x="41" y="17" />
        <position x="34" y="17" />
        <position x="34" y="17" />
        <position x="33" y="17" />
      </connection>
    <comment>SM2-MU gateway IP address</comment>
    </variable>
    <variable name="chanCode" type="UINT">
      <connection refid="19">
        <position x="41" y="19" />
        <position x="36" y="19" />
        <position x="36" y="19" />
        <position x="35" y="19" />
      </connection>
    <comment>communication channel number</comment>
    </variable>
    <variable name="tcp" type="BOOL">
      <connection refid="18">
        <position x="41" y="21" />
        <position x="38" y="21" />
        <position x="38" y="21" />
        <position x="37" y="21" />
      </connection>
    <comment>protocol type - TRUE = TCP, FALSE = UDP</comment>
    </variable>
    <variable name="DevInfoPtr" type="PTR_TO TDeviceBlockInfo">
      <connection refid="16">
        <position x="41" y="23" />
        <position x="21" y="23" />
        <position x="21" y="27" />
        <position x="12" y="27" />
      </connection>
    <comment>pointer to array start</comment>
    </variable>
    <variable name="DevInfoSize" type="USINT">
      <connection refid="7">
        <position x="41" y="25" />
        <position x="23" y="25" />
        <position x="23" y="30" />
        <position x="11" y="30" />
      </connection>
    <comment>max. number of devices (array size)</comment>
    </variable>
    <variable name="InverterPtr" type="PTR_TO TInverter">
      <connection refid="8">
        <position x="41" y="27" />
        <position x="25" y="27" />
        <position x="25" y="33" />
        <position x="10" y="33" />
      </connection>
    <comment>Pointer to array of Inverter structures</comment>
    </variable>
    <variable name="InverterCount" type="USINT">
      <connection refid="12">
        <position x="41" y="29" />
        <position x="27" y="29" />
        <position x="27" y="36" />
        <position x="13" y="36" />
      </connection>
    <comment>max. number of Inverters (array size)</comment>
    </variable>
    <variable name="StringBoxPtr" type="PTR_TO TStringBox">
      <connection refid="9">
        <position x="41" y="31" />
        <position x="29" y="31" />
        <position x="29" y="39" />
        <position x="3" y="39" />
      </connection>
    <comment>Pointer to array of StringBox structures</comment>
    </variable>
    <variable name="StringBoxCount" type="USINT">
      <connection refid="13">
        <position x="41" y="33" />
        <position x="31" y="33" />
        <position x="31" y="42" />
        <position x="3" y="42" />
      </connection>
    <comment>max. number of Inverters (array size)</comment>
    </variable>
    <variable name="BatteryPtr" type="PTR_TO TBattery">
      <connection refid="10">
        <position x="41" y="35" />
        <position x="33" y="35" />
        <position x="33" y="45" />
        <position x="3" y="45" />
      </connection>
    <comment>Pointer to array of Battery structures</comment>
    </variable>
    <variable name="BatteryCount" type="USINT">
      <connection refid="14">
        <position x="41" y="37" />
        <position x="35" y="37" />
        <position x="35" y="48" />
        <position x="3" y="48" />
      </connection>
    <comment>max. number of Batteries (array size)</comment>
    </variable>
    <variable name="MeterPtr" type="PTR_TO TMeter">
      <connection refid="11">
        <position x="41" y="39" />
        <position x="37" y="39" />
        <position x="37" y="51" />
        <position x="3" y="51" />
      </connection>
    <comment>Pointer to array of Meter structures</comment>
    </variable>
    <variable name="MeterCount" type="USINT">
      <connection refid="15">
        <position x="41" y="41" />
        <position x="39" y="41" />
        <position x="39" y="54" />
        <position x="3" y="54" />
      </connection>
    <comment>max. number of Meters (array size)</comment>
    </variable>
  </inVariables>
  <outVariables>
    <variable name="done" type="BOOL">
    <comment>block finished</comment>
    </variable>
    <variable name="busy" type="BOOL">
    <comment>block is still running</comment>
    </variable>
    <variable name="err" type="BOOL">
    <comment>block ended with error</comment>
    </variable>
    <variable name="errCode" type="USINT">
    <comment>error code</comment>
    </variable>
    <variable name="errTxt" type="STRING[80]">
    <comment>error report</comment>
    </variable>
    <variable name="devCount" type="USINT">
    <comment>number of devices in the SM2-MU gateway</comment>
    </variable>
    <variable name="DevTypeCount" type="TDeviceTypeCount">
    <comment>structure with count of each device type</comment>
    </variable>
  </outVariables>
</block>
<inVariable name="smInit_enable" type="BOOL" id="3">
  <position x="1" y="14" />
</inVariable>
<inVariable name="IP_Address" type="STRING" id="4">
  <position x="1" y="17" />
</inVariable>
<inVariable name="chanCode" type="UINT" id="5">
  <position x="1" y="20" />
</inVariable>
<inVariable name="tcp" type="BOOL" id="6">
  <position x="1" y="23" />
</inVariable>
<inVariable name="DEVICE_COUNT" type="USINT" id="7">
  <position x="1" y="29" />
</inVariable>
<inVariable name="ADR(Inverter)" type="" id="8">
  <position x="0" y="32" />
</inVariable>
<inVariable name="0" type="" id="9">
  <position x="1" y="38" />
</inVariable>
<inVariable name="0" type="" id="10">
  <position x="0" y="44" />
</inVariable>
<inVariable name="0" type="" id="11">
  <position x="1" y="50" />
</inVariable>
<inVariable name="INVERTER_COUNT" type="USINT" id="12">
  <position x="1" y="35" />
  <comment>
 maximalni pocet zarizeni typu Inverter   </comment>
</inVariable>
<inVariable name="0" type="" id="13">
  <position x="1" y="41" />
</inVariable>
<inVariable name="0" type="" id="14">
  <position x="1" y="47" />
</inVariable>
<inVariable name="0" type="" id="15">
  <position x="1" y="53" />
</inVariable>
<inVariable name="ADR(DeviceInfo)" type="" id="16">
  <position x="1" y="26" />
</inVariable>
<node id="17">
  <position x="33" y="17" />
  <connection refid="4">
    <position x="33" y="17" />
    <position x="17" y="17" />
    <position x="17" y="18" />
    <position x="8" y="18" />
  </connection>
</node>
<node id="18">
  <position x="37" y="21" />
  <connection refid="6">
    <position x="37" y="21" />
    <position x="19" y="21" />
    <position x="19" y="24" />
    <position x="4" y="24" />
  </connection>
</node>
<node id="19">
  <position x="35" y="19" />
  <connection refid="5">
    <position x="35" y="19" />
    <position x="17" y="19" />
    <position x="17" y="21" />
    <position x="8" y="21" />
  </connection>
</node>
<block name="SR" instance="pcRead_SR" id="20" height="6" width="6" line="21" order="5">
  <position x="79" y="12" />
  <inVariables>
    <variable name="S1" type="BOOL">
      <connection refid="2" name="done">
        <position x="79" y="15" />
        <position x="64" y="15" />
        <position x="64" y="15" />
        <position x="57" y="15" />
      </connection>
    </variable>
    <variable name="R" type="BOOL">
      <connection refid="31">
        <position x="79" y="17" />
        <position x="77" y="17" />
        <position x="77" y="9" />
        <position x="108" y="9" />
        <position x="108" y="15" />
        <position x="108" y="15" />
      </connection>
    </variable>
  </inVariables>
  <outVariables>
    <variable name="Q1" type="BOOL">
    </variable>
  </outVariables>
</block>
<block name="fb_SMPowerControl" instance="smPcRead" id="21" height="18" width="12" line="22" order="6">
  <position x="90" y="12" />
  <inVariables>
    <variable name="enable" type="BOOL">
      <connection refid="20" name="Q1">
        <position x="90" y="15" />
        <position x="87" y="15" />
        <position x="87" y="15" />
        <position x="85" y="15" />
      </connection>
    <comment>if enable=0, block is disabled, start with rising edge</comment>
    </variable>
    <variable name="ip" type="STRING[80]">
      <connection refid="28">
        <position x="90" y="17" />
        <position x="89" y="17" />
        <position x="89" y="5" />
        <position x="89" y="5" />
      </connection>
    <comment>SM2-MU gateway IP address</comment>
    </variable>
    <variable name="chanCode" type="UINT">
      <connection refid="29">
        <position x="90" y="19" />
        <position x="88" y="19" />
        <position x="88" y="6" />
        <position x="88" y="6" />
      </connection>
    <comment>communication channel number</comment>
    </variable>
    <variable name="tcp" type="BOOL">
      <connection refid="30">
        <position x="90" y="21" />
        <position x="87" y="21" />
        <position x="87" y="7" />
        <position x="87" y="7" />
      </connection>
    <comment>protocol type - TRUE = TCP, FALSE = UDP</comment>
    </variable>
    <variable name="read" type="BOOL">
      <connection refid="32">
        <position x="90" y="23" />
        <position x="85" y="23" />
        <position x="85" y="23" />
        <position x="83" y="23" />
      </connection>
    <comment>TRUE - reading, FALSE - writting</comment>
    </variable>
    <variable name="active" type="BOOL">
      <connection refid="33">
        <position x="90" y="25" />
        <position x="85" y="25" />
        <position x="85" y="25" />
        <position x="83" y="25" />
      </connection>
    <comment>TRUE - active power, FALSE - reactive power</comment>
    </variable>
    <variable name="InverterPtr" type="PTR_TO TInverter">
      <connection refid="34">
        <position x="90" y="27" />
        <position x="89" y="27" />
        <position x="89" y="27" />
        <position x="79" y="27" />
      </connection>
    </variable>
  </inVariables>
  <outVariables>
    <variable name="done" type="BOOL">
    <comment>block finished</comment>
    </variable>
    <variable name="busy" type="BOOL">
    <comment>block is still running</comment>
    </variable>
    <variable name="err" type="BOOL">
    <comment>block ended with error</comment>
    </variable>
    <variable name="errCode" type="USINT">
    <comment>error code</comment>
    </variable>
    <variable name="errTxt" type="STRING[80]">
    <comment>error report</comment>
    </variable>
  </outVariables>
  <inOutVariables>
    <variable name="pwctrl" type="INT">
      <connection refid="38">
        <position x="90" y="29" />
        <position x="89" y="29" />
        <position x="89" y="30" />
        <position x="73" y="30" />
      </connection>
    <comment>set/read power value {CSY } nastavovana / prectena hodnota vykonu</comment>
    </variable>
  </inOutVariables>
</block>
<block name="OR" instance="" function="true" extensible="true" hiddenPins="true" operator="true" id="22" height="4" width="3" line="29" order="7">
  <position x="116" y="14" />
  <inVariables>
    <variable name="IN1" type="ANY_BIT">
      <connection refid="31">
        <position x="116" y="15" />
        <position x="109" y="15" />
        <position x="109" y="15" />
        <position x="108" y="15" />
      </connection>
    </variable>
    <variable name="IN2" type="ANY_BIT">
      <connection refid="44">
        <position x="116" y="17" />
        <position x="108" y="17" />
        <position x="108" y="37" />
        <position x="108" y="37" />
      </connection>
    </variable>
  </inVariables>
  <outVariables>
    <variable name="OR" type="ANY_BIT">
    <comment>Bitwise OR
	compares every bits on same position in IN1, IN2, ... and generates a 1 result
	if either or all bits are 1, otherwise it returns 0
</comment>
    </variable>
  </outVariables>
</block>
<block name="SR" instance="pcWrite_SR" id="23" height="6" width="6" line="31" order="8">
  <position x="126" y="12" />
  <inVariables>
    <variable name="S1" type="BOOL">
      <connection refid="22" name="OR">
        <position x="126" y="15" />
        <position x="120" y="15" />
        <position x="120" y="15" />
        <position x="119" y="15" />
      </connection>
    </variable>
    <variable name="R" type="BOOL">
      <connection refid="43">
        <position x="126" y="17" />
        <position x="124" y="17" />
        <position x="124" y="9" />
        <position x="154" y="9" />
        <position x="154" y="15" />
        <position x="154" y="15" />
      </connection>
    </variable>
  </inVariables>
  <outVariables>
    <variable name="Q1" type="BOOL">
    </variable>
  </outVariables>
</block>
<block name="fb_SMPowerControl" instance="smPcWrite" id="24" height="18" width="12" line="32" order="9">
  <position x="137" y="12" />
  <inVariables>
    <variable name="enable" type="BOOL">
      <connection refid="23" name="Q1">
        <position x="137" y="15" />
        <position x="133" y="15" />
        <position x="133" y="15" />
        <position x="132" y="15" />
      </connection>
    <comment>if enable=0, block is disabled, start with rising edge</comment>
    </variable>
    <variable name="ip" type="STRING[80]">
      <connection refid="28">
        <position x="137" y="17" />
        <position x="136" y="17" />
        <position x="136" y="5" />
        <position x="89" y="5" />
      </connection>
    <comment>SM2-MU gateway IP address</comment>
    </variable>
    <variable name="chanCode" type="UINT">
      <connection refid="29">
        <position x="137" y="19" />
        <position x="135" y="19" />
        <position x="135" y="6" />
        <position x="88" y="6" />
      </connection>
    <comment>communication channel number</comment>
    </variable>
    <variable name="tcp" type="BOOL">
      <connection refid="30">
        <position x="137" y="21" />
        <position x="134" y="21" />
        <position x="134" y="7" />
        <position x="87" y="7" />
      </connection>
    <comment>protocol type - TRUE = TCP, FALSE = UDP</comment>
    </variable>
    <variable name="read" type="BOOL">
      <connection refid="35">
        <position x="137" y="23" />
        <position x="132" y="23" />
        <position x="132" y="23" />
        <position x="130" y="23" />
      </connection>
    <comment>TRUE - reading, FALSE - writting</comment>
    </variable>
    <variable name="active" type="BOOL">
      <connection refid="36">
        <position x="137" y="25" />
        <position x="131" y="25" />
        <position x="131" y="25" />
        <position x="130" y="25" />
      </connection>
    <comment>TRUE - active power, FALSE - reactive power</comment>
    </variable>
    <variable name="InverterPtr" type="PTR_TO TInverter">
      <connection refid="46">
        <position x="137" y="27" />
        <position x="132" y="27" />
        <position x="132" y="27" />
        <position x="126" y="27" />
      </connection>
    </variable>
  </inVariables>
  <outVariables>
    <variable name="done" type="BOOL">
    <comment>block finished</comment>
    </variable>
    <variable name="busy" type="BOOL">
    <comment>block is still running</comment>
    </variable>
    <variable name="err" type="BOOL">
    <comment>block ended with error</comment>
    </variable>
    <variable name="errCode" type="USINT">
    <comment>error code</comment>
    </variable>
    <variable name="errTxt" type="STRING[80]">
    <comment>error report</comment>
    </variable>
  </outVariables>
  <inOutVariables>
    <variable name="pwctrl" type="INT">
      <connection refid="37">
        <position x="137" y="29" />
        <position x="136" y="29" />
        <position x="136" y="30" />
        <position x="120" y="30" />
      </connection>
    <comment>set/read power value {CSY } nastavovana / prectena hodnota vykonu</comment>
    </variable>
  </inOutVariables>
</block>
<block name="SR" instance="timer_SR" id="25" height="6" width="6" line="10" order="1">
  <position x="111" y="40" />
  <inVariables>
    <variable name="S1" type="BOOL">
      <connection refid="45">
        <position x="111" y="43" />
        <position x="110" y="43" />
        <position x="110" y="34" />
        <position x="110" y="34" />
      </connection>
    </variable>
    <variable name="R" type="BOOL">
      <connection refid="44">
        <position x="111" y="45" />
        <position x="108" y="45" />
        <position x="108" y="37" />
        <position x="108" y="37" />
      </connection>
    </variable>
  </inVariables>
  <outVariables>
    <variable name="Q1" type="BOOL">
    </variable>
  </outVariables>
</block>
<block name="TON" instance="timer" id="26" height="6" width="5" line="11" order="2">
  <position x="137" y="40" />
  <inVariables>
    <variable name="IN" type="BOOL">
      <connection refid="25" name="Q1">
        <position x="137" y="43" />
        <position x="124" y="43" />
        <position x="124" y="43" />
        <position x="117" y="43" />
      </connection>
    <comment>input</comment>
    </variable>
    <variable name="PT" type="TIME">
      <connection refid="39">
        <position x="137" y="45" />
        <position x="133" y="45" />
        <position x="133" y="45" />
        <position x="130" y="45" />
      </connection>
    <comment>preset</comment>
    </variable>
  </inVariables>
  <outVariables>
    <variable name="Q" type="BOOL">
    <comment>output</comment>
    </variable>
    <variable name="ET" type="TIME">
    <comment>value</comment>
    </variable>
  </outVariables>
</block>
<block name="CTU" instance="counter" id="27" height="8" width="5" line="46" order="10">
  <position x="91" y="38" />
  <inVariables>
    <variable name="CU" type="BOOL R_EDGE">
      <connection refid="45">
        <position x="91" y="41" />
        <position x="89" y="41" />
        <position x="89" y="34" />
        <position x="110" y="34" />
      </connection>
    <comment>up</comment>
    </variable>
    <variable name="R" type="BOOL">
      <connection refid="41">
        <position x="91" y="43" />
        <position x="89" y="43" />
        <position x="89" y="43" />
        <position x="86" y="43" />
      </connection>
    <comment>reset</comment>
    </variable>
    <variable name="PV" type="INT">
      <connection refid="40">
        <position x="91" y="45" />
        <position x="88" y="45" />
        <position x="88" y="45" />
        <position x="87" y="45" />
      </connection>
    <comment>preset</comment>
    </variable>
  </inVariables>
  <outVariables>
    <variable name="Q" type="BOOL">
    <comment>output</comment>
    </variable>
    <variable name="CV" type="INT">
    <comment>value</comment>
    </variable>
  </outVariables>
</block>
<node id="28">
  <position x="89" y="5" />
  <connection refid="17">
    <position x="89" y="5" />
    <position x="33" y="5" />
    <position x="33" y="17" />
    <position x="33" y="17" />
  </connection>
</node>
<node id="29">
  <position x="88" y="6" />
  <connection refid="19">
    <position x="88" y="6" />
    <position x="35" y="6" />
    <position x="35" y="19" />
    <position x="35" y="19" />
  </connection>
</node>
<node id="30">
  <position x="87" y="7" />
  <connection refid="18">
    <position x="87" y="7" />
    <position x="37" y="7" />
    <position x="37" y="21" />
    <position x="37" y="21" />
  </connection>
</node>
<node id="31">
  <position x="108" y="15" />
  <connection refid="21" name="done">
    <position x="108" y="15" />
    <position x="107" y="15" />
    <position x="107" y="15" />
    <position x="102" y="15" />
  </connection>
</node>
<inVariable name="true" type="BOOL" id="32">
  <position x="79" y="22" />
</inVariable>
<inVariable name="true" type="BOOL" id="33">
  <position x="79" y="24" />
</inVariable>
<inVariable name="ADR(Inverter[InverterIdx])" type="" id="34">
  <position x="63" y="26" />
</inVariable>
<inVariable name="false" type="BOOL" id="35">
  <position x="126" y="22" />
</inVariable>
<inVariable name="true" type="BOOL" id="36">
  <position x="126" y="24" />
</inVariable>
<inVariable name="pwrctrl[idx].val" type="UINT" id="37">
  <position x="110" y="29" />
</inVariable>
<inVariable name="pwctrl_val_read" type="UINT" id="38">
  <position x="63" y="29" />
  <comment>
pozadovana hodnota vykonu [%]  </comment>
</inVariable>
<inVariable name="pwrctrl[idx].period" type="TIME" id="39">
  <position x="118" y="44" />
</inVariable>
<inVariable name="2" type="" id="40">
  <position x="85" y="44" />
</inVariable>
<inVariable name="counter.Q" type="BOOL" id="41">
  <position x="79" y="42" />
  <comment>
vstup tae  </comment>
</inVariable>
<outVariable name="idx" type="INT" id="42" order="11">
  <position x="99" y="42" />
  <connection refid="27" name="CV">
    <position x="100" y="43" />
    <position x="98" y="43" />
    <position x="98" y="43" />
    <position x="96" y="43" />
  </connection>
</outVariable>
<node id="43">
  <position x="154" y="15" />
  <connection refid="24" name="done">
    <position x="154" y="15" />
    <position x="153" y="15" />
    <position x="153" y="15" />
    <position x="149" y="15" />
  </connection>
</node>
<node id="44">
  <position x="108" y="37" />
  <connection refid="26" name="Q">
    <position x="108" y="37" />
    <position x="145" y="37" />
    <position x="145" y="43" />
    <position x="142" y="43" />
  </connection>
</node>
<node id="45">
  <position x="110" y="34" />
  <connection refid="43">
    <position x="110" y="34" />
    <position x="154" y="34" />
    <position x="154" y="15" />
    <position x="154" y="15" />
  </connection>
</node>
<inVariable name="ADR(Inverter[InverterIdx])" type="" id="46">
  <position x="110" y="26" />
</inVariable>
<outVariable name="timer_ET" type="TIME" id="47" order="3">
  <position x="145" y="44" />
  <connection refid="26" name="ET">
    <position x="146" y="45" />
    <position x="144" y="45" />
    <position x="144" y="45" />
    <position x="142" y="45" />
  </connection>
</outVariable>
</fbd>
{/NOCODE}
//LVD
VAR
(* 245	*)	_Tmp_For_Back_Conn_5	:	BOOL;
(* 396	*)	_Tmp_For_Back_Conn_4	:	BOOL;
(* 701	*)	_Tmp_For_Back_Conn_3	:	BOOL;
(* 566	*)	_Tmp_For_Back_Conn_2	:	BOOL;
(* 692	*)	_Tmp_For_Back_Conn_1	:	BOOL;
END_VAR

//TVD
VAR_TEMP
(* 699	*)	_Nod_Tmp_8	:	BOOL;
(* 690	*)	_Nod_Tmp_7	:	BOOL;
(* 206	*)	_Nod_Tmp_6	:	STRING[80];
(* 224	*)	_Nod_Tmp_5	:	UINT;
(* 215	*)	_Nod_Tmp_4	:	BOOL;
(* 629	*)	_Nod_Tmp_3	:	BOOL;
(* 681	*)	_Nod_Tmp_1	:	BOOL;
END_VAR

//NC
//N003
(* 701	*)	LD	_Tmp_For_Back_Conn_3
//N000
(* 699	*)	ST	_Nod_Tmp_8
//N008
(* 692	*)	LD	_Tmp_For_Back_Conn_1
//N000
(* 690	*)	ST	_Nod_Tmp_7
(* 506	*)	CAL	timer_SR(S1:=_Nod_Tmp_8, R:=_Nod_Tmp_7)
(* 531	*)	CAL	timer(IN:=timer_SR.Q1, PT:=pwrctrl[idx].period)
(* 531	*)	LD 	timer.ET
(* 711	*)	ST 	timer_ET
(* 165	*)	LD 	IP_Address
(* 206	*)	ST	_Nod_Tmp_6
(* 168	*)	LD 	chanCode
(* 224	*)	ST	_Nod_Tmp_5
(* 171	*)	LD 	tcp
(* 215	*)	ST	_Nod_Tmp_4
(*   8	*)	CAL	smInit(enable:=smInit_enable, ip:=_Nod_Tmp_6, chanCode:=_Nod_Tmp_5, tcp:=_Nod_Tmp_4, DevInfoPtr:=ADR(DeviceInfo), DevInfoSize:=DEVICE_COUNT, InverterPtr:=ADR(Inverter), InverterCount:=INVERTER_COUNT, StringBoxPtr:=0, StringBoxCount:=0, BatteryPtr:=0, BatteryCount:=0, MeterPtr:=0, MeterCount:=0)
(* 233	*)	CAL	pcRead_SR(S1:=smInit.done, R:=_Tmp_For_Back_Conn_5)
(* 260	*)	CAL	smPcRead(enable:=pcRead_SR.Q1, ip:=_Nod_Tmp_6, chanCode:=_Nod_Tmp_5, tcp:=_Nod_Tmp_4, read:=true, active:=true, InverterPtr:=ADR(Inverter[InverterIdx]), pwctrl:=void(pwctrl_val_read))
(* 260	*)	LD 	smPcRead.done
(* 629	*)	ST	_Nod_Tmp_3
//N001
(* 245	*)	ST	_Tmp_For_Back_Conn_5
//N000
(* 359	*)	LD 	_Nod_Tmp_3
(* 367	*)	OR 	_Nod_Tmp_7
(* 384	*)	ST 	pcWrite_SR.S1
(* 384	*)	CAL	pcWrite_SR(R:=_Tmp_For_Back_Conn_4)
(* 411	*)	CAL	smPcWrite(enable:=pcWrite_SR.Q1, ip:=_Nod_Tmp_6, chanCode:=_Nod_Tmp_5, tcp:=_Nod_Tmp_4, read:=false, active:=true, InverterPtr:=ADR(Inverter[InverterIdx]), pwctrl:=void(pwrctrl[idx].val))
(* 411	*)	LD 	smPcWrite.done
(* 681	*)	ST	_Nod_Tmp_1
//N002
(* 396	*)	ST	_Tmp_For_Back_Conn_4
//N000
(* 681	*)	LD	_Nod_Tmp_1
//N003
(* 701	*)	ST	_Tmp_For_Back_Conn_3
//N000
(* 699	*)	LD	_Nod_Tmp_8
//N006
(* 566	*)	ST	_Tmp_For_Back_Conn_2
//N007
(* 562	*)	CAL	counter(CU:=_Tmp_For_Back_Conn_2, R:=counter.Q, PV:=2)
(* 562	*)	LD 	counter.CV
(* 672	*)	ST 	idx
//N000
(* 531	*)	LD 	timer.Q
//N008
(* 692	*)	ST	_Tmp_For_Back_Conn_1

END_PROGRAM
