
//// Ukazka pouziti funkcniho bloku pro rizeni vykonu
PROGRAM prgMain
  VAR CONSTANT
    IP_Address : STRING := '192.168.1.125:502';
    chanCode : UINT := ETH1_uni0;
    tcp : BOOL := true;
    
    InverterIdx : USINT := 1;          // logicke id zarizeni v SM2-MU, kteremu nastavujeme vykon
    INVERTER_COUNT  : USINT := 4;      (* maximalni pocet zarizeni typu Inverter  *)
    DEVICE_COUNT    : USINT := INVERTER_COUNT;
    active : BOOL := true;             // TRUE - aktivni vykon, FALSE - jalovy vykon
    read : BOOL := false;              // TRUE - cteni, FALSE - zapis
  END_VAR

  VAR
    pwctrl_value : INT := 60;         // nastavovan hodnota

    DeviceInfo : ARRAY [1 .. DEVICE_COUNT] OF TDeviceBlockInfo;
    Inverter  : ARRAY [1 .. INVERTER_COUNT] OF TInverter;
    smInit_enable : BOOL := true;
    smPC_enable : BOOL;

    smInit : fb_SMInit;
    smPC : fb_SMPowerControl;
    smFini : fb_SMFini;
  END_VAR

  // pocatecni detekce pritomnych zarizeni
smInit(enable := smInit_enable, ip := IP_Address, tcp := tcp, chanCode := chanCode, DevInfoPtr := ADR(DeviceInfo), DevInfoSize := DEVICE_COUNT, InverterPtr := ADR(Inverter), InverterCount := INVERTER_COUNT, StringBoxPtr := 0, StringBoxCount := 0, BatteryPtr := 0, BatteryCount := 0, MeterPtr := 0, MeterCount := 0);

  IF smInit.done THEN
    smInit_enable := false;
    smPC_enable := true;
  END_IF;

  // jednorazove nastaveni vykonu
  smPC(enable := smPC_enable, ip := IP_Address, tcp := tcp, read := read, chanCode := chanCode, pwctrl := pwctrl_value, active := active, InverterPtr := ADR(Inverter[InverterIdx]));

  IF smPC.done THEN
    smPC_enable := false;
    smFini(tcp := tcp);
  END_IF;

END_PROGRAM


